'
' ####################
' #####  PROLOG  #####
' ####################
'
' A demo of using expat xml parsing library.
'
VERSION "0.0001"
CONSOLE
'
	IMPORT  "xst_s.lib"				' Standard library : required by most programs
'	IMPORT  "xsx"				' Extended standard library
	IMPORT	"libexpat"	' expat XML parser
'	IMPORT  "xio"				' Console input/ouput library
' IMPORT	"gdi32"			' gdi32.dll
'	IMPORT  "user32"		' user32.dll
	IMPORT  "kernel32"	' kernel32.dll
'	IMPORT  "shell32"		' shell32.dll
'	IMPORT  "msvcrt"		' msvcrt.dll

'
DECLARE FUNCTION Entry ()
DECLARE FUNCTION GetUTF8$ (pString, cByte)
DECLARE CFUNCTION VOID startElement(userData, name, atts)
DECLARE CFUNCTION VOID endElement(userData, name)
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

  buffer$ = SPACE$(256)						'allocate a buffer
  parser = XML_ParserCreate(NULL)	'create the parser
	done = $$FALSE		'book keeping
  depth = 0					'book keeping
  XML_SetUserData(parser, &depth)
  XML_SetElementHandler(parser, &startElement(), &endElement())		'register the callbacks
	'get a file to read
	file$ = "test.xml"
	n = OPEN(file$, $$RD)
	IF n = -1 THEN
		PRINT "Error: unable to open "; file$
		GOTO exit
	END IF

	'parse the file
  DO
		buffer$ = SPACE$(256)		'flush the buffer each time
		READ[n], buffer$
    len = LEN(buffer$)
    IF POF(n) >= LOF(n) THEN done = $$TRUE		'done = $$TRUE if this is the last piece
    IF (XML_Parse(parser, &buffer$, len, done) = $$XML_STATUS_ERROR) THEN		'basic error handling
      PRINT "ERROR ";CSTRING$(XML_ErrorString(XML_GetErrorCode(parser)));" at line ";XML_GetCurrentLineNumber(parser)
      RETURN $$TRUE
    END IF
  LOOP WHILE !done
  XML_ParserFree(parser)		'must remember this or there could be a memory leak

exit:
  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION

CFUNCTION VOID startElement(userData, name, atts)		'callback for start tags
	depthPtr = userData

	' indent two spaces for each level of depth
	FOR i = 0 TO XLONGAT(depthPtr)-1
    PRINT "  ";
	NEXT
	
	' get name
  PRINT GetUTF8$(name, -1)
	
	' get attribute name and value pair
	
  XLONGAT(depthPtr) = XLONGAT(depthPtr) + 1
END FUNCTION

CFUNCTION VOID endElement(userData, name)		'callback for end tags
  depthPtr = userData
  XLONGAT(depthPtr) = XLONGAT(depthPtr) - 1
END FUNCTION
'
' ######################
' #####  GetUTF8$  #####
' ######################
' Retreive a UTF8 string and convert it to ansi replacing non ansi characters with ?
' Use cByte = -1 for null terminated strings
' returns an empty string on fail
FUNCTION GetUTF8$ (pString, cByte)
	USHORT	wideCharString[]
	DIM wideCharString[0]

	'convert to wide charcter string
	cWC = MultiByteToWideChar ($$CP_UTF8, 0, pString, cByte, &wideCharString[0], 0)
	IFZ cWC THEN RETURN ""		'there was an error
	DIM wideCharString[cWC-1]
	MultiByteToWideChar ($$CP_UTF8, 0, pString, cByte, &wideCharString[0], cWC)

	'convert to ANSI string, replacing unicode characters with ?
	ret$ = SPACE$(cWC)
	FOR i = 0 TO cWC - 1
		IFZ (wideCharString[i] AND 0xFF00) THEN 'upper bits are clear
			UBYTEAT(&ret$, i) = UBYTEAT(&wideCharString[i])
		ELSE	'this is a unicode character
			UBYTEAT(&ret$, i) = '?'
		END IF
	NEXT

	DIM wideCharString[-1]	'deallocate RAM
	RETURN ret$
END FUNCTION

END PROGRAM